#import "IWriteAppDelegate.h"

@interface IWriteWindow: NSWindow
{
}
@end

@implementation IWriteWindow

- (BOOL)acceptsFirstResponder
{
	NSLog(@"accepts\n");
	return YES;
}

@end


@implementation IWriteAppDelegate
- (BOOL)isFullScreen
{
	return fullScreen;
}

- (void)setFullScreen:(BOOL)sender
{
	fullScreen = sender;
}

- (void)exitFullScreen
{
	[self setFullScreen:NO];
	
	NSView *content = [fullScreenWindow contentView];
	[content retain];
	[fullScreenWindow setContentView:nil];
	[desktopWindow setContentView:content];
	[content release];

	[fullScreenWindow orderOut:self];
	[fullScreenWindow release];
	if(CGDisplayRelease(kCGDirectMainDisplay) != kCGErrorSuccess)
	{
		NSLog(@"Couldn't release the display");
	}
}

- (void)enterFullScreen
{
	[self setFullScreen:YES];
	
	int windowLevel;
	NSRect screenRect;
	
	if(CGDisplayCapture(kCGDirectMainDisplay) != kCGErrorSuccess)
	{
		NSLog(@"Couldn't capture the main display!");
	}
	
	windowLevel = CGShieldingWindowLevel();
	screenRect = [[NSScreen mainScreen] frame];
	
	NSView *content = [desktopWindow contentView];
	[content retain];
	[desktopWindow setContentView:nil];

	fullScreenWindow = [[IWriteWindow alloc] initWithContentRect:screenRect styleMask:NSBorderlessWindowMask backing:NSBackingStoreBuffered defer:NO screen:[NSScreen mainScreen]];
	[fullScreenWindow setContentView:content];
	[content release];
	
	[fullScreenWindow makeKeyAndOrderFront:nil];
	[fullScreenWindow makeFirstResponder:content];
	[fullScreenWindow setLevel:windowLevel];
}

- (IBAction)toggleFullScreen:(id)sender {
    
	if([self isFullScreen])
		[self exitFullScreen];
	else
		[self enterFullScreen];
}

- (void)applicationDidFinishLaunching:(NSNotification *) note
{
	fullScreen = NO;
}

@end
